package epggrab;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

import java.io.*;
import java.util.*;

public class EPGGrab extends Thread
{
    private static String dir = null;
    private static String exe = null;
    private static String dest = null;
    private static int hour = 4;

    private static FileWriter log = null;
    private static File newDataFile = null;
    private static FileWriter guideData = null;
    private static FileWriter applicationOutput = null;

    public EPGGrab()
    {
    }

    public static void main( String[] args )
    {
        if (getProps())
        {
            Thread t = new EPGGrab();
            t.start();
        }
    }

    public void run()
    {
        boolean waiting = true;
        while ( true )
        {
            Calendar c = Calendar.getInstance();
            System.out.println("Waiting: " +waiting + ", Hour: " + c.get(c.HOUR_OF_DAY));
            if (c.get(c.HOUR_OF_DAY) == hour )
            {
                if (waiting == true)
                {
                    waiting = false;
                    if ( openFiles() )
                    {
                        getEPGData();
                    }
                }
            }
            else
            {
                waiting = true;
            }

            try
            {
                Thread.currentThread().sleep( 60 * 1000 );
            }
            catch ( InterruptedException ex )
            {
                break;
            }
        }
    }

    private static boolean getProps()
    {
        boolean rv = true;
        sub:
            {
            ResourceBundle bundle = null;
            try
            {
                bundle = ResourceBundle.getBundle( "EPGGrab" );
            }
            catch ( Exception e )
            {
                writeLog( "Unable to find EPGGrab.properties\n" );
                rv = false;
                break sub;
            }
            dir = bundle.getString( "executablePath" );
            if ( dir == null )
            {
                writeLog(
                    "Can't find executablePath property in the properties file\n" );
                rv = false;
                break sub;
            }
            exe = bundle.getString( "executableCommand" );
            if ( exe == null )
            {
                writeLog(
                    "Can't find executableCommand property in the properties file\n" );
                rv = false;
                break sub;
            }

            dest = bundle.getString( "destinationDirectory" );
            if ( dest == null )
            {
                writeLog(
                    "Can't find destinationDirectory property in the properties file\n" );
                rv = false;
                break sub;
            }
            String temp = bundle.getString( "hourToRun" );
            if ( temp != null )
            {
                try
                {
                    hour = Integer.parseInt( temp );
                }
                catch ( NumberFormatException nfe )
                {
                    writeLog(
                        "hourToRun property is not a number!\n" );
                    rv = false;
                    break sub;

                }
            }
        }
        return rv;
    }

    private static boolean openFiles()
    {
        boolean rv = true;
        sub:
            {
            try
            {
                newDataFile = new File( dest + "\\epgdatanew.xml" );
                guideData = new FileWriter( newDataFile, false );
                applicationOutput = new FileWriter( "Application_Output.txt", false );
            }
            catch ( IOException e )
            {
                writeLog( "Couldn't open file: " + e.getMessage() +
                          "\n" );
                rv = false;
                break sub;
            }
        }
        return rv;
    }


    private static void closeFiles()
    {
        if ( applicationOutput != null )
        {
            try
            {
                applicationOutput.close();
            }
            catch ( IOException ex1 )
            {
            }
        }
        if ( guideData != null )
        {
            try
            {
                guideData.close();
            }
            catch ( IOException ex2 )
            {
            }
        }
    }

    private static void getEPGData()
    {
        writeLog( "Attempting to grab new data\n" );

        sub:
            {
            try
            {

                File workingDir = new File( dir );
                if ( !workingDir.exists() || !workingDir.isDirectory() )
                {
                    writeLog( "Couldn't open working dir: " + dir + "\n" );
                    break sub;
                }

                String command = dir + "\\" + exe;

                // Couldn't get it to work with working dir... not sure why
                // Might be a bug in my jre version.
//                Process proc = Runtime.getRuntime().exec( command, new String[0],
//                    workingDir );

                Process proc = Runtime.getRuntime().exec( command );
                // handle error messages
                StreamHandler errorHandler = new StreamHandler( proc.
                    getErrorStream(), applicationOutput );

                // handle input streams
                StreamHandler inputHandler = new StreamHandler( proc.
                    getInputStream(), guideData );

                // kick them off
                errorHandler.start();
                inputHandler.start();

                // any error
                // any error
                int exitVal = proc.waitFor();

                while ( !errorHandler.isDone || !inputHandler.isDone() )
                {
                // wait for the stream to finish being read;
                }

                try
                {
                    if ( exitVal != 0 )
                    {
                        writeLog(
                            "Failed to execute the epg data grabber. Exit Value = " +
                            exitVal + "\n" );
                        break sub;
                    }
                }
                finally
                {
                    proc.destroy();
                }

                if ( newDataFile.length() > 0 )
                {
                    writeLog( "Successfully retrieved data.\n" );
                }
                else
                {
                    writeLog( "No data retrieved!\n" );
                    break sub;
                }

                closeFiles();

                // A few times the renames failed without an exception
                // I haven't had a chance to track down why, but I tossed
                // in some sleeps in case the delete's were interfering with the renames
                File bak = new File( dest + "\\epgdata.bak" );
                if ( bak.exists() )
                {
                    bak.delete();
                    sleep(3);
                }
                File old = new File( dest + "\\epgdata.xml" );
                if ( old.exists() )
                {
                    old.renameTo( bak );
                    sleep(3);
                }

                newDataFile.renameTo( old );

            }
            catch ( Exception e )
            {
                writeLog( "An error occurred: " + e + "\n" );
            }
        }

    }

    public static void sleep(int seconds)
    {
        try
        {
            Thread.currentThread().sleep( 1000 * seconds );
        }
        catch ( InterruptedException ex )
        {
            // do nothing
        }
    }

    // Always open and close the log when writing.  Not really efficient, but
    // stupid apps like wordpad won't open the file if this thing has it open.
    public static void writeLog( String str )
    {
        try
        {
            log = new FileWriter( "EPGGrab_Log.txt", true );
        }
        catch ( IOException e )
        {
            e.printStackTrace();
        }

        if ( log != null )
        {
            try
            {
                long now = System.currentTimeMillis();
                Date timestamp = new Date( now );
                log.write( "[" + timestamp.toString() + "] " + str );
                log.flush();
                log.close();
            }
            catch ( IOException e )
            {
                e.printStackTrace();
            }
        }
    }

}